\usepackage{tikz}
\usepackage{ifthen}
\usepackage{hyperref}
\usepackage{xparse}
\usepackage{enumitem}
\usepackage{textcomp}
\usepackage{varwidth}
\usepackage{graphicx}
\usepackage{relsize}
\usepackage{fancyvrb}
\usepackage{ragged2e}
\usepackage{needspace}

\usepackage{tabu}
\usepackage{diagbox}
\usepackage{booktabs}
\usepackage{array}
\usepackage{tabularx}
\usepackage{array}
\usepackage{colortbl}
\usepackage{pgfplotstable}

\newcolumntype{C}{>{\centering\arraybackslash}X}
\newcolumntype{L}{>{\raggedright\arraybackslash}X}
\newcolumntype{R}{>{\raggedleft\arraybackslash}X}

\usepackage{templates/semirounded}
\usepackage{templates/mzcode}
\useinnertheme{rounded}

\usetikzlibrary{positioning}
\usetikzlibrary{shapes}
\usetikzlibrary{decorations}
\usetikzlibrary{decorations.pathmorphing}
\usetikzlibrary{calc}
\usetikzlibrary{automata}
\usetikzlibrary{datavisualization}
\usetikzlibrary{arrows.meta}
\usetikzlibrary{fit}
\usetikzlibrary{graphs}
\usetikzlibrary{decorations.shapes}
\usetikzlibrary{decorations.markings}
\usetikzlibrary{backgrounds}
\usetikzlibrary{scopes}

\usepackage[linesnumbered,vlined,commentsnumbered]{algorithm2e}
\SetKwInput{Input}{input~}
\SetKwInput{Output}{output~}
\SetVlineSkip{-0.4pt}
\SetKwFor{ForEach}{for each}{do}{}

\renewcommand{\algocf@Vline}[1]{%     no vskip in between boxes but a strut to separate them, 
	\strut\par\nointerlineskip% then interblock space stay the same whatever is inside it
	\algocf@push{\skiprule}%        move to the right before the vertical rule
	\hbox{\vrule\hspace{-0.4pt}%
		\vtop{\algocf@push{\skiptext}%move the right after the rule
			\vtop{\algocf@addskiptotal #1}\Hlne}}\vskip\skiphlne% inside the block
	\algocf@pop{\skiprule}%\algocf@subskiptotal% restore indentation
	\nointerlineskip}% no vskip after

\mode<presentation>

\providecommand{\colorprovide}[2]{\@ifundefined{\string\color@#1}{\colorlet{#1}{#2}}{}}

\tikzset{
	%Define standard arrow tip
	>=stealth,
	% Define arrow style
	pil/.style={
		->,
		thick,
		shorten <=2pt,
		shorten >=2pt,},
	invisible/.style={opacity=0},
	hidden/.style={opacity=0.15},
	visible on/.code={%
		\ifthenelse{\equal{#1}{}}{%
			\tikzset{alt={<\value{beamerpauses}->{}{invisible}}}%
		}{%
			\tikzset{alt={#1{}{invisible}}}%
		}%
		%alt={#1{}{invisible}}
	},
	show on/.code={%
		\ifthenelse{\equal{#1}{}}{%
			\tikzset{alt={<\value{beamerpauses}->{}{hidden}}}%
		}{%
			\tikzset{alt={#1{}{hidden}}}%
		}%
		%alt={#1{}{hidden}}
	},
	alt/.code args={<#1>#2#3}{%
		\alt<#1>{\pgfkeysalso{#2}}{\pgfkeysalso{#3}} % \pgfkeysalso doesn't change the path
	},
}

\setbeamercovered{transparent}
\newcommand<>{\newFrame}{\only#1{\addtocounter{framenumber}{1}}}

\newcommand<>{\showgraphic}[2][]{%
	\begin{tikzpicture}%
		\node[inner sep=0pt, outer sep=0pt, minimum size=0pt, show on=#3](){\includegraphics[#1]{#2}};%
	\end{tikzpicture}%
}
\newcommand<>{\showkitgraphic}[2][]{%
	\begin{tikzpicture}%
	\node[transparent, inner sep=0pt, outer sep=0pt, minimum size=0pt](image){\includegraphics[#1]{#2}};%
	\path[clip]
		(image.south east){[rounded corners=1.5mm] --
		(image.south west)} --
		(image.north west){[rounded corners=1.5mm] --
		(image.north east)} --
	cycle
	{};
	\draw[show on=#3] (image) node[inner sep=0pt, outer sep=0pt, minimum size=0pt] {\includegraphics[#1]{#2}};
	\end{tikzpicture}%
}

\newcommand{\checkviewer}{%
	\begin{tikzpicture}
	\path[clip]
		(0,1ex){[rounded corners=0.3ex] --
		(1ex,1ex)} --
		(1ex,0){[rounded corners=0.3ex] --
		(0,0)} --
	cycle
	{};
	\fill[red] (0,0) rectangle (1ex,1ex);
	\filldraw[rounded corners, green,line width=10ex] (0,2ex) -- cycle;
	\end{tikzpicture}%
}

\newbox\@backgroundblock
\NewDocumentEnvironment{background}{ O{0mm} O{0mm} O{noclip} }{%
	\setlength{\kitbottom}{\ifbeamer@plainframe1mm\else9mm\fi}%
	\global\setbox\@backgroundblock=\vbox\bgroup%
	\unvbox\@backgroundblock%
	\begin{pgfpicture}%
		\pgftext[at=\pgfpoint{#1}{-#2},top,left]\bgroup%
			\begin{varwidth}{\paperwidth-#1}%
}{%
			\end{varwidth}%
		\egroup%
	\end{pgfpicture}%
	\egroup%
}
\addtobeamertemplate{background}{\box\@backgroundblock}{}

\NewDocumentEnvironment{foreground}{ O{0mm} O{0mm}}{%
	\begin{textblock*}{\paperwidth}(#1,#2)%
}{%
	\end{textblock*}%
}

% \TikzCoord{node name}{Text}
\newcommand{\TikzCoord}[2]{%
	\tikz[remember picture, baseline=(#1.base)]{%
		\node [inner sep=0, outer sep=0, text depth=.25ex, text height=1.5ex] (#1) {%
			\begin{varwidth}[b]{\linewidth}%
				#2%
			\end{varwidth}%
		};%
	}%
}

\colorprovide{highlightColor}{green}
\newcommand<>{\highlight}[2][highlightColor]{%
	\TikzCoord{tmpcoord}{#2}%
	\begin{background}%
		\begin{tikzpicture}[remember picture, overlay,visible on=#3]%
		\filldraw [#1,line width=1pt]
			($(tmpcoord.south east)+(+0.2ex,-0.2ex)$){[rounded corners=1.5mm] --
			($(tmpcoord.south west)+(-0.2ex,-0.2ex)$)} --
			($(tmpcoord.north west)+(-0.2ex,+0.2ex)$){[rounded corners=1.5mm] --
			($(tmpcoord.north east)+(+0.2ex,+0.2ex)$)} --
		cycle
		{};
		\end{tikzpicture}%
	\end{background}%
}

\newcommand{\centerbox}[3]{%
	\begin{pgfpicture}{0mm}{0mm}{#1}{#2}%
		\pgftext[at=\pgfpoint{0.5*#1}{0.5*#2}]{%
			\begin{varwidth}{\linewidth}%
				#3%
			\end{varwidth}%
		}%
	\end{pgfpicture}%
}

\colorprovide{bulletColor}{green}
\newlength{\myTotalHeight}
\newcommand{\kitBulletNumbered}[2][bulletColor]{%
	\pgfmathsetlength{\myTotalHeight}{depth("p")+height("H")}%
	\begin{pgfpicture}{0mm}{0.5*depth("p")}{\myTotalHeight}{\myTotalHeight}%
		{\pgfsetcornersarced{\pgfpoint{.3*\myTotalHeight}{.3*\myTotalHeight}} 
			\pgfpathmoveto{\pgfpoint{0em}{\myTotalHeight}} 
			\pgfpathlineto{\pgfpoint{\myTotalHeight}{\myTotalHeight}}
			\pgfpathlineto{\pgfpoint{\myTotalHeight}{0em}}}
		{\pgfsetcornersarced{\pgfpoint{.3*\myTotalHeight}{.3*\myTotalHeight}}
			\pgfpathmoveto{\pgfpoint{\myTotalHeight}{0em}}
			\pgfpathlineto{\pgfpointorigin}
			\pgfpathlineto{\pgfpoint{0em}{\myTotalHeight}}}
		\color{#1}
		\pgfusepath{fill}
		\pgftext[at=\pgfpoint{.5*\myTotalHeight}{.5*\myTotalHeight}]{\textcolor{white}{\smaller#2}}
	\end{pgfpicture}%
}

%CH: KIT-point
\newcommand{\kitBullet}[1][bulletColor]{%
	\begin{pgfpicture}{0mm}{0mm}{1ex}{1ex}%
		{\pgfsetcornersarced{\pgfpoint{.3ex}{.3ex}} 
			\pgfpathmoveto{\pgfpoint{0cm}{1ex}} 
			\pgfpathlineto{\pgfpoint{1ex}{1ex}}
			\pgfpathlineto{\pgfpoint{1ex}{0cm}}}
		{\pgfsetcornersarced{\pgfpoint{.3ex}{.3ex}}
			\pgfpathmoveto{\pgfpoint{1ex}{0cm}}
			\pgfpathlineto{\pgfpointorigin}
			\pgfpathlineto{\pgfpoint{0cm}{1ex}}}
		\color{#1}
		\pgfusepath{fill}
	\end{pgfpicture}%
}


\newcommand{\qedideasymbol}{%
	\begin{pgfpicture}{0mm}{0mm}{1ex}{1ex}
		{\pgfsetcornersarced{\pgfpoint{.3ex}{.3ex}} 
			\pgfpathmoveto{\pgfpoint{0cm}{1ex}} 
			\pgfpathlineto{\pgfpoint{1ex}{1ex}}
			\pgfpathlineto{\pgfpoint{1ex}{0cm}}}
		{\pgfsetcornersarced{\pgfpoint{.3ex}{.3ex}}
			\pgfpathmoveto{\pgfpoint{1ex}{0cm}}
			\pgfpathlineto{\pgfpointorigin}
			\pgfpathlineto{\pgfpoint{0cm}{1ex}}}
		\color{black}
		\pgfusepath{draw}
	\end{pgfpicture}%
}

\renewcommand\qedsymbol{\kitBullet[black]}

\ifbeamer@ams
	\renewenvironment<>{proof}[1][\proofname]{%
		\par
		\def\insertproofname{#1}%
		\pushQED{\qed}
		\usebeamertemplate{proof begin}#2}
	{\popQED\usebeamertemplate{proof end}}
\fi

\newenvironment{proofSketch}[1][\proofname\iflanguage{english}{~Sketch}{idee}]
{\begin{proof}[#1]\renewcommand\qedsymbol{\qedideasymbol}}
{\end{proof}}

\NewDocumentCommand{\startFrame}{ O{\insertsection} O{\insertsubsection} O{\thesection} }{
	\begin{frame}{~}%show kit logo...
		\vspace{8em}
		\vbox{\hsize=\linewidth\bfseries\strut\Huge%
			\kitBulletNumbered{#3}\hspace{0.33em}#1
			\strut}%
		\ifx#2\empty\else%
		\vspace{-1mm}
		\vbox{\hsize=\linewidth\bfseries\strut\Large\hspace{2.238em}#2\strut}%
		\fi%
	\end{frame}
}

\NewDocumentCommand{\kitbox}{ O{green} O{\linewidth} m }{
	\begin{varwidth}{#2}
		\colorlet{bulletColor}{#1}%
		\begin{tikzpicture}[baseline=(text.base)]
		\node[baseline=0pt](text){%
			\begin{varwidth}[b]{#2-8.1pt}%
			#3%
			\end{varwidth}%
		};
		\begin{scope}[on background layer]
		\draw [#1,fill=#1!15,line width=1pt]
			(text.south east){[rounded corners=1.5mm] --
			(text.south west)} --
			(text.north west){[rounded corners=1.5mm] --
			(text.north east)} --
		cycle
		{};
		\end{scope}
		\end{tikzpicture}
	\end{varwidth}
}

\NewDocumentCommand{\kitframe}{ O{green} O{\linewidth} m }{
	\begin{varwidth}{#2}%
		\colorlet{bulletColor}{#1}%
		\begin{tikzpicture}[baseline=(text.base)]
		\node[baseline=0pt,inner sep=0.25pt](text){%
			\begin{varwidth}[b]{#2-8.1pt}%
			#3%
			\end{varwidth}%
		};
		\begin{scope}[on background layer]
		\draw [#1,fill=#1,line width=1pt]
			(text.south east){[rounded corners=1.5mm] --
			(text.south west)} --
			(text.north west){[rounded corners=1.5mm] --
			(text.north east)} --
		cycle
		{};
		\end{scope}
		\end{tikzpicture}%
	\end{varwidth}%
}

\newenvironment{kitblock}[2]{%
	\setbeamercolor*{example text}{fg=black}%
	\setbeamercolor*{block title example}{fg=white,bg=#1}%
	\setbeamercolor*{block body example}{fg=black,bg=#1!15}%
	\begin{exampleblock}{#2}%
	}{%
	\end{exampleblock}%
}

\providecommand{\setCodeColors}{}
\newenvironment{pseudocode}[3]{%
	\setCodeColors%
	\begin{exampleblock}{#1}%
		\hfill%
		\begin{minipage}{\linewidth-1.5em}%
			\begin{algorithm}[H]%
				\vspace{-3pt}%
				\DontPrintSemicolon%
				\Input{\hspace{1.29ex}#2}%
				\Output{#3}%
				\BlankLine%
			}{%
			\end{algorithm}%
		\end{minipage}%
	\end{exampleblock}%
}%

\NewDocumentEnvironment{code}{ m m }{\begingroup\VerbatimOut[tabsize=4]{listings-temp.vrb}}
{\endVerbatimOut\setCodeColors\begin{block}{#2}\lstinputlisting[language=#1,style=basestyle]{listings-temp.vrb}\end{block}\endgroup}

\providecommand{\setTableColors}{}
\NewDocumentEnvironment{boxedtable}{ m m m O{} }{%
	\setTableColors%
	\begin{exampleblock}{#1}%
		\begin{tabu}{#2}%
			#3 \\%
			\midrule%
		}{
		\ifx#4\empty\else\midrule\fi%
		\end{tabu}%
		\ifx#4\empty\else%
			\vspace{-0.6em}%
			\begin{itemize}%
				\item #4%
			\end{itemize}%
			\vspace{-0.4em}%
		\fi%
	\end{exampleblock}%
}%

\setbeamertemplate{itemize items}{\kitBullet}
\setlist{label=\kitBullet,leftmargin=2.4ex}
\setlist[itemize,2]{before*=\footnotesize}
\setlist[enumerate]{leftmargin=3ex}
\setlist[enumerate,1]{label=\kitBulletNumbered{\arabic*}}
\setlist[enumerate,2]{before*=\footnotesize,label=\kitBulletNumbered{\Roman*}}
\setlist[enumerate,3]{before*=\footnotesize,label=\kitBulletNumbered{\alph*}}
\setbeamertemplate{section in toc}{%
	\kitBulletNumbered{\inserttocsectionnumber}\,~\inserttocsection%
}
\setbeamertemplate{subsection in toc}{~~~~~\kitBullet\,~\inserttocsubsection\\}

%% use this for setting the total page number
\newcommand{\beginbackup}{
	\newcounter{framenumbervorappendix}
	\setcounter{framenumbervorappendix}{\value{framenumber}}
}
\newcommand{\backupend}{
	\addtocounter{framenumbervorappendix}{-\value{framenumber}}
	\addtocounter{framenumber}{\value{framenumbervorappendix}} 
}

\mode<all>